<?php
require_once('../core/inc.php');
fnc::check_user(2);
$step = isset($_GET['step']) ? fnc::check($_GET['step']) : false;
switch($step) {
default:
fnc::go('?step=1');
break;
case '1':
$conf['title'] = 'Добавить в мошенники | Шаг 1';
require_once(inc.'core/header.php');
fnc::head('<a href="/">Главная</a>&#187;<a href="index.php">База мошенников</a>&#187; Добавить в мошенники | Шаг 1');

if (isset($_POST['ok'])) {
$who = isset($_POST['who']) ? abs((int)$_POST['who']) : false;
if (empty($who)) {
$err .=' Введите ID юзера на данном ресурсе!';
} elseif (!is_numeric($who)) {
$err .='Разрешено вводить только цифры!';
} elseif ($who < 1 OR $who > 10000) {
$err .='Что то с длиной ID...';
} elseif (core::$dbs->querySingle("SELECT COUNT(id) FROM `users` WHERE `id` = ?", [$who]) == 0) {
$err .='Нет такого пользователя!';
} elseif (core::$dbs->querySingle("SELECT COUNT(id) FROM `black_list` WHERE `who` = ?", [$who]) > 0) {
$err .='Пользователь уже есть в Базе мошенников!';
}
if (empty($err)) {
$_SESSION['user'] = $who;
fnc::go('?step=2');
}
else fnc::message($err, 'error');
}
echo '<div class="raz"><form action="?step=1" method="post">ID юзера:<br/><input type="text" name="who" '.(!empty($_SESSION['user']) ? 'value="'.$_SESSION['user'].'"':NULL).'/><br/><input type="submit" name="ok" value="Далее"/></form></div>';
break;
case '2':
if (empty($_SESSION['user'])) fnc::go('?step=1');
$conf['title'] = 'Добавить в мошенники | Шаг 2';
require_once(inc.'core/header.php');
fnc::head('<a href="/">Главная</a>&#187;<a href="index.php">База мошенников</a>&#187; Добавить в мошенники | Шаг 2');
$who = $_SESSION['user'];
$wm = core::$dbs->queryFetch("SELECT wmid,wmr FROM `wm` WHERE id_us = ? LIMIT 1",array($who));
if (isset($_POST['ok'])) {
$name = fnc::check($_POST['name']);
$nick = fnc::check($_POST['nick']);
$opis = fnc::check($_POST['opis']);
$mail = fnc::check($_POST['mail']);
$icq = abs(intval($_POST['icq']));
$wmid = fnc::check($_POST['wmid']);
if (empty($opis)) {
$err .= 'Заполните все обязательные поля!';
} elseif (core::$dbs->querySingle("SELECT COUNT(id) FROM `black_list` WHERE `who` = ?", [$who]) > 0) {
$err .='Пользователь уже есть в Базе мошенников!';
}
if (empty($err)) {
core::$dbs->query("INSERT INTO black_list SET name = ?, nick = ?, opis = ?, who = ?, id_us = ?, type = ?, wmid = ?, icq = ?, mail = ?, time = ?",array($name,$nick,$opis,$who,$user_id,1,$wmid,$icq,$mail,time()));
$last_id = core::$dbs->lastInsertId();
session_destroy();
if ($_POST['addsrc'] == 1) {
fnc::go('addscr.php?id='.$last_id);
} else fnc::message('Ваша информация добавлена и отправлена на проверку администрации!');
}
else {
fnc::message($err, 'error');
}
}
echo '<div class="raz">Пользователь <b>'.fnc::user_inf($who, 'user').'</b><br/>
<form action="?step=2" method="post">* Ник на данном проекте:<br/><input type="text" name="name" value="'.fnc::user_inf($who, 'user').'"/><br/>
Другие ники (через запятую):<br/><input type="text" name="nick"/><br/>
* WMID:<br/><input type="text" name="wmid" '.($wm['wmid'] != 0 ? ' value="'.$wm['wmid'].'"':NULL).'/><br/>
* WMR:<br/><input type="text" name="wmr" '.($wm['wmr'] != 0 ? ' value="'.$wm['wmr'].'"':NULL).'/><br/>
ICQ:<br/><input type="text" name="icq" '.(fnc::user_inf($who, 'icq') != 0 ? ' value="'.fnc::user_inf($who, 'icq').'"':NULL).'/><br/>
E-mail:<br/><input type="text" name="mail" '.(fnc::user_inf($who, 'mail') != NULL ? 'value="'.fnc::user_inf($who, 'mail').'"':NULL).'/><br/>
* Описание (доки, ссылки на скрины, фото, ссылки на темы):<br/><textarea name="opis"></textarea><br/>
<input type="checkbox" name="addsrc" value="1"/> Добавить скриншоты<br/>
<input type="submit" name="ok" value="Добавить"/></form></div>';
break;
}
require_once(inc.'core/footer.php');
?>