<?php
require_once(inc.'down/pclzip.lib.php');
require_once(inc.'down/func.php');

//------Подсвечиваем код-----//
function hightlight($code) {
$code = stripslashes($code);
if(!strpos($code,"<?") && substr($code,0,2)!="<?"){
$code="<?php
".trim($code)."
?>";}
$code = trim($code);
$code=highlight_string($code,true);
return '<div class="code">'.$code.'</div>';
}
//---------------//
$onpage = 10;
$id = abs(intval($_GET['id']));
$page = abs(intval($_GET['page']));
$start = abs(intval($_GET['start']));
$act = (isset($_GET['act']) && $_GET['act'] == 'preview') ? fnc::check($_GET['act']) : NULL;
$d = core::$dbs->queryFetch("SELECT * FROM `fo` WHERE `id` = ?",array($id));

$di = '../upload/zc/'.$d['file'];
if (!file_exists($di)){
fnc::message('file not found','error');
require_once inc.'core/footer.php';
exit();
}
$conf['title'] = 'Просмотр архива '.$d['name'];
require_once(inc.'core/header.php');
fnc::head('Просмотр архива '.$d['name']);
if (!empty($d['pass'])) {
fnc::message('Файл под паролем!','error');
require_once(inc.'core/footer.php');
die();
}
############Получаем каталог#############
$filename = pathinfo($di);
$ext = strtolower($filename['extension']);
if ($ext != 'zip') die('Файл не является ZIP архивом');
$dir = $filename['dirname'] . '/';
$back = core::$dbs->queryFetch("SELECT * FROM `fo` WHERE `file` = ?",array($dir));
if (!$act) {
$zip = new PclZip($di);
if (!$list = $zip->listContent()) die('Ошибка: '.$zip->errorInfo(true));
for($i = 0; $i < sizeof($list); ++$i){
for(reset($list[$i]); $key = key($list[$i]); next($list[$i]))
{
$zfilesize = strstr($listcontent, '--size');
$zfilesize = str_replace('--size:', '', $zfilesize);
$zfilesize = str_replace($zfilesize, $zfilesize . '|', $zfilesize);
$sizelist .= $zfilesize;
$listcontent = "[$i]--$key:" . $list[$i][$key];
$zfile = strstr($listcontent, '--filename');
$zfile = str_replace('--filename:', '', $zfile);
$zfile = str_replace($zfile, $zfile . '|', $zfile);
$savelist .= $zfile;
}
}
$sizefiles2 = explode('|', $sizelist);

$sizelist2 = array_sum($sizefiles2);
$obkb = round($sizelist2 / 1024, 2);
$preview = $savelist;

$preview = explode('|', $preview);

$count = count($preview) - 1;
echo'<div class="raz">Всего файлов: ' .$count . '<br/>Вес распакованного архива: ' . $obkb . ' kb</div>';
if (!isset($page)) $page = 1;
$n = 0;
$pages = ceil($count / $onpage);
if (!$pages) $pages = 1;
if ($page) $n = ($onpage * $page) - $onpage;
if ($count == 0) fnc::message('Пусто...');
$sizefiles = explode('|', $sizelist);
$selectfile = explode('|', $savelist);
//------------------------------------------------------------------------------------------
$open = fnc::check($_GET['open']);
for ($i = 1; $i <= $onpage; ++$i)
{
if (empty($selectfile[$n]))
{
$n++;
continue;
}

$path = $selectfile[$n];
$fname = $path;
//$fname = preg_replace('/.*[/]/', '', $path);
#$zdir = preg_replace('/[/]?[^/]*$/', '', $path);
echo '<div class="raz">';
echo '<a href="/down/zip/preview/'.$id.'?open='.$path.'">' . $fname.'</a>';
if ($sizefiles[$n] != 0) echo ' [' . round($sizefiles[$n] / 1024, 2) . 'kb]';
echo '<br/>';
echo'</div>';
$n++;
}

echo '<div class="page">';
echo 'Страницы: ';
$asd = $page - 2;
$asd2 = $page + 3;
if ($asd < $count && $asd > 0 && $page > 3) echo '<a href="/down/zip/'.$id.'?page=1">1</a> ... ';
for($i = $asd; $i < $asd2; $i++)
{
if ($i < $count && $i > 0)
{
if ($i > $pages) break;
if ($page == $i) echo '<b>[' . $i . ']</b> ';
else echo '<a href="/down/zip/'.$id.'?page='.$i.'">' . $i . '</a> ';
}
}
if ($i <= $pages)
{
if ($asd2 < $count) echo ' ... <a href="/down/zip/'.$id.'?page='.$pages.'">' . $pages . '</a>';
}
echo '</div>';
}
/* Просмотр файла */
if ($act == 'preview')
{
$open = htmlspecialchars(trim($_GET['open']));
if (strpos($open , '..') !== false or strpos($open , './') !== false)
{
fnc::message('В хакера решил поиграть?');
require_once inc.'core/footer.php';
exit();
}

$zip = new PclZip($di);
$content = $zip->extract(PCLZIP_OPT_BY_NAME, $open, PCLZIP_OPT_EXTRACT_AS_STRING);
$content = $content[0]['content'];
$preview2 = explode("n", $content);
$count = count($preview2);
echo '<div class="ank"><b>Файл: ' . $open . '</b></div>';
$eX = strtolower(strrchr($open, '.'));

$php = array('.php', '.pl', '.js', '.jsp', '.html', '.xhtml', '.xml', '.wml', '.asp', '.aspx');
$txt = array('.txt', '.sql', '.dat', '.css', '.ini', '.function', '.htaccess', '.tpl');
$img = array('.gif', '.jpg', '.jpeg', '.png', '.bmp', '.wbmp', '.ico', '.swf');

if (empty($content)) fnc::message('Файл пуст.','error');
if (isset($_GET['img'])){
$ext = strtolower(substr($open, strrpos($open, '.') + 1));
ob_end_clean();
ob_clean();

header("Content-type: image/$ext");
header("Content-Length: " . strlen($content));
header('Content-Disposition: inline; filename="' . $open . '"');

echo $content;
exit();
}

if (in_array($eX, $php))
{
echo  (!empty($content) ? '<div class="ank">Строк: ' . $count . '</div>' : '');
if (is_utf($content)) echo hightlight($content);
else echo hightlight(win_to_utf($content));
}
elseif (in_array($eX, $txt))
{
$content = htmlspecialchars($content);
echo  (!empty($content) ? '<div class="page">Строк: ' . $count . '</div>' : '');
if ($content) echo '<div class="ank"><code>' . wordwrap($content, 75, '<br/>') . '</code></div>';
else echo '<div class="ank"><code>' . win_to_utf(wordwrap($content, 75, '<br/>')) . '</code></div>';
}
elseif (in_array($eX, $img)){
echo '<div class="ank"><img src="/down/zip/preview/'.$id.'?open='.$open.'&amp;img" alt=""/></div>';
}
else
{
fnc::message('Невозможно прочесть файл!','error');
}
}
echo '<div class="menu_j"><a href="/down/file/'.$id.'" class="top_menu_j">К файлу</a></div>';
if (isset($_GET['act'])) echo '<div class="menu_j"><a href="/down/zip/'.$id.'" class="top_menu_j">К просмотру архива</a></div>';
require_once inc.'core/footer.php';
exit;
?>
