<?php
$days = date('d');
$hi = date('H');
$is = date('i');
require_once('../core/inc.php');
fnc::check_user(2);
$id = abs(intval($_GET['id']));
$raz = core::$dbs->queryFetch("SELECT * FROM `gaz_r` WHERE `id` = ? LIMIT 1",array($id));
if (empty($raz['name'])){
fnc::message('Такого раздела нет!');
require_once inc.'core/footer.php';
exit();
}
$conf['title'] = 'Добавление статьи';
require_once(inc.'core/header.php');
fnc::head('<a href="/">Главная</a>&#187;<a href="/gazeta">Газета сайта</a>&#187;Добавить статью');
if(core::$user['jur']!=1 && $level<6){header('location:/gazeta/cat/'.$id);}
if (isset($_POST['ok'])) {
$title = fnc::check($_POST['title']);
$day = intval($_POST['day']);
$h = intval($_POST['h']);
$i = intval($_POST['i']);
if ($_POST['timer'] == 1) {
if ($h < $hi OR $i < $is) {
$err .= 'Ошибка в таймере!';
}
$timer = $day.'-'.$h.'-'.$i;
} else {
$timer = '';
}
$latname = fnc::retrans($title);
$latname = preg_replace("/[^A-z0-9_-]/i", "",$latname);
if (core::$dbs->querySingle("SELECT COUNT(id) FROM `gaz` WHERE `title`=?",array($title)) > 0) {
$err .='Статья с таким названием уже существует в Базе!';
}
$content = fnc::check($_POST['content']);
$tags = fnc::check($_POST['tags']);
if (empty($title) OR empty($content)) {
$err .='Заполните название и содержание!';
}
$FileName = $_FILES['file']['name'];
$FileSize = $_FILES['file']['size'];
$GetExt = ['.bmp',
'.gif','.jpeg','.jpg','.png'];
$ext = strtolower(strrchr($FileName, '.'));
if (!empty($FileName)) {
if (!preg_match('#([a-z0-9-_]{1,32})#i', $FileName)) {
$err .= 'Не правильное имя файла!';
}
if ($FileSize > 1024 * 2 * 1024) {
$err .= 'Размер файла более 2 Мб!';
}
if (!in_array($ext, $GetExt)) {
$err .= 'Запрещенный формат файла!';
}
}

if (empty($err)) {
$file = (!empty($FileName) ? 'upload/gazeta/gazeta_'.mt_rand(1000, 9999) . $ext : '');
if (!empty($FileName)) {
copy($_FILES['file']['tmp_name'], inc . $file);
}
core::$dbs->query("INSERT INTO `gaz` SET `title` = ?, `content` = ?, `time` = ?, `id_r` = ?, `login` = ?, `tags` = ?, `latname` = ?, `file` = ?, `timer` = ?",array($title,$content,time(),$id,$user_id,$tags,$latname,$file,$timer));
$idl = core::$dbs->lastInsertId();
$array = core::$dbs->queryFetch("SELECT latname,id FROM `gaz` WHERE `id` = ? LIMIT 1",array($idl));
header('location:/gazeta/'.$array['latname'].'.html');
die();
} else fnc::message($err, 'error');
}
echo '<div class="raz"><form action="/gazeta/add/'.$id.'" method="post" enctype="multipart/form-data" name="form">
Название:<br />
<input name="title" maxlength="255" /><br /
>Содержание:<br/>';
bbcode::auto_bb('form', 'content');
echo'<textarea name="content"></textarea><br />
Теги (через запятую):<br/><input name="tags" maxlength="255" /><br />
Картинка:<br/><input type="file" name="file"/><br/>';
echo '<input type="submit" name="ok" value="Добавить"/></form></div>';
require_once(inc . 'core/footer.php');
?>
