<?php
require_once('core/inc.php');
fnc::check_user(0);
$conf['title'] = 'Восстановление Пароля';
require_once(inc.'core/header.php');
echo '<div class="posted">Выберите способ восстановления пароля</div>';
$act = isset($_GET['act']) ? fnc::check($_GET['act']) : false;
switch($act){
default:
echo '<div class="menu_j"><a href="?act=mail" class="top_menu_j">По E-mail</a></div>';
echo '<div class="menu_j"><a href="?act=vopros" class="top_menu_j">Секретный вопрос</a></div>';
break;
case 'mail':
if(isset($_POST['nick']) && $_POST['nick']!=''){
$array = !is_numeric($_POST['nick']) ? mb_strtolower(fnc::rus_to_k($_POST['nick'])) : abs((int)$_POST['nick']);
$where = !is_numeric($_POST['nick']) ? "`latuser`=?":"`id`=?";
$inf = core::$dbs->queryFetch("SELECT `id`,`user`,`pass`,`mail_secret`,`email_sess`,`email_yes`,`email_kod` FROM `users` WHERE $where LIMIT 1",array($array));
if ($inf['id'] == 0) fnc::message('<b>Такого пользователя не существует!</b>','error');
else {
$to = $inf['mail_secret'];
$vnick = $inf['user'];
$vid = $inf['id'];
if($to == '') fnc::message('Ошибка, У Вас не был заполнен секретный E-mail в анкете, восстановление не возможно! Обратитесь к администрации для восстановления пароля!','error');
else {
$kod = rand(100000,999999,a-z,A-Z);
core::$dbs->query("UPDATE `users` SET `email_kod` = ?, `email_sess` = ? WHERE `id` = ?",array(md5($kod),time()-7200,$vid));
$mes = 'Здравствуйте! Был произведен запрос на восстановление пароля на сайте '.homeurl.'<br/>Перейдите по ссылке '.homeurl.'/lostpass.php?act=check&kod='.md5($kod).' для подтверждения восстановления пароля.
<br/>Ссылка будет действительна в течении 2-х часов.
<br/>Если вы не подавали запроса то настоятельно рекомендуем вам сменить пароль в настройках сайта.
С уважением Администрация.';
$from = 'pass@masteram.us';

@mail($to, "Recover Pass", $mes,
"From: $from \r\n"
."Content-Type: text/html; charset=\"utf-8\" \r\n"
."X-Mailer: PHP/" . phpversion());

//fnc::SendEmail($to, $from, 'Восстановление пароля', $mes, 'masteram.us');
echo '<div class="raz">На ваш e-mail указанный при регистрации была отправлена ссылка для подтверждения восстановления пароля.</div>';
}
}
} else {
echo '<div class="raz"><form action="?act=mail" method="post">Bаш ник / id:<br/><input name="nick" value="'.$us.'"/><br/><input type="submit" value="Восстановить!"/></form></div>';
}
break;
case 'check':
$kod = isset($_GET['kod']) ? fnc::check($_GET['kod']) : false;
$inf = core::$dbs->queryFetch("SELECT * FROM users WHERE email_kod = ? LIMIT 1",array($kod));
if (empty($inf['email_kod'])) {
fnc::message('Ошибка!','error');
require_once(inc.'core/footer.php');
exit;
}
if($inf['email_sess']>time()-72000){
fnc::message('Вышло время отведенное на восстановление пароля!','error');
require_once(inc.'core/footer.php');
exit;
}
if (empty($inf['id'])) {
header('location:/');
}
$newpass = fnc::pass(12);
core::$dbs->query("UPDATE users SET pass = ? WHERE id = ? LIMIT 1",array(md5(md5($newpass)),$inf['id']));
core::$dbs->query("UPDATE users SET email_kod = ?, email_sess = ? WHERE id = ? LIMIT 1",array('','',$inf['id']));
$mes = 'Ваш новый пароль: <b>'.$newpass.'</b><br/>
С ув. Администрация <b>'.homeurl.'</b>';
$from = 'lostpass@masteram.us';
@mail($inf['mail_secret'], "Recover Pass", $mes,
"From: $from \r\n"
."Content-Type: text/html; charset=\"utf-8\" \r\n"
."X-Mailer: PHP/" . phpversion());
echo '<div class="raz">Новый пароль отправлен на ваш е-mail указанный при регистрации.</div>';
break;

case 'vopros':

echo 'Введите Ваш Ник/ID:<br/>
<form method="post" action="?act=next">
<input type="text" name="nick"/>
<br/>
<input type="submit" name="go" value="Далее"/>
</form>';
/*
echo '<b> Временно не работает!</b>';*/
break;

case 'next':
$array = !is_numeric($_POST['nick']) ? mb_strtolower(fnc::rus_to_k($_POST['nick'])) : abs(intval($_POST['nick']));
$where = !is_numeric($_POST['nick']) ? "`latuser`=?":"`id`=?";
$select = core::$dbs->query("SELECT `id`,`user`,`pass`,`answer`,`vopros` FROM `users` WHERE $where LIMIT 1",array($array));  /*тут уже запрос на проверку */
$info = $select -> fetch(); /*помоему тут что то не то, почему в обычном же работает*/
if(isset($_POST['ok'])){
$ans = fnc::check(sha1(md5($_POST['answer'])));
if (empty($ans)){
fnc::message('Не введен ответ на секретный вопрос!','error');
} elseif ($info['answer'] != $ans) {
fnc::message('Неверный ответ на секретный вопрос!','error');
} elseif ($info['answer'] == $ans) {  /*тут если правильно ввели ответ, то генерирует новый , записывает в базу и даёт на экран юзеру*/
$newpass = fnc::pass(12);  
core::$dbs->query("UPDATE `users` SET `pass` = ? WHERE `id` = ? LIMIT 1",array(md5(md5($newpass)),$info['id']));
echo '<div class="raz">Ваш пароль: <b>'.$newpass.'</b></div>';
}
}
if ($select->rowCount()== FALSE) {
fnc::message('Пользователь с таким ником/id не найден!','error');
} elseif ($info['vopros']==0) {
fnc::message('У вас не установлен секретный вопрос!','error');
} else {
if ($info['vopros'] == 1) $Q = 'Девичья фамилия матери?';
elseif ($info['vopros'] == 4) $Q = 'Кличка домашнего животного?';
elseif ($info['vopros'] == 3) $Q = 'Номер паспорта?';
elseif ($info['vopros'] == 2) $Q = 'Любимый цвет?';
echo '<form method="POST" action="?act=next">'.$Q.'<br/>
<label>Ответ:</label><br/><input type="text" name="answer"/>
<br/>
<input type="hidden" name="nick" value="'.$array.'"/>
<input type="submit" name="ok" value="Восстановить"/></form>';
}
break;
}
echo '<div class="menu_j"><a href="/" class="top_menu_j">'.fnc::icon('home.png').' Главная</a></div>';
require_once(inc.'core/footer.php');
?>
