<?php
class bbcode extends core
{
/*
-----------------------------------------------------------------
Обработка тэгов и ссылок
-----------------------------------------------------------------
*/
public static function tags($var) {
$var = self::highlight_code($var);           // Подсветка кода
$var = self::highlight_url($var);            // Обработка ссылок
$var = self::OLD_highlight_url($var);        // Обработка ссылок в BBcode
$var = self::highlight_bb($var);             // Обработка ссылок
$var = self::highlight_bb_img($var);             // Обработка ссылок url
$var = self::us_bb($var);
return $var;
}
function links($text)
{
$text = preg_replace('|http:\/\/www\.|is','http://',$text);

$text = preg_replace('|www\.|is','http://',$text);

$text = preg_replace('/(http:\/\/([\w\d\.\?\&\#\;\:\+\-\=\%\/]+))/i', '<a class="link" href="/away?url=$1" >$1</a>', $text);

$text = preg_replace('/(www\.([a-zA-Z_0-9\.\?\&\#\;\:\+\-\=\%\/]*))/i', '<a class="link" href="/away?url=http://$1" >$1</a>', $text);
$text = preg_replace('|/away\?url=https:\/\/masteram\.us|is','https://masteram.us',$text);

$text = preg_replace('|/away\?url=wwww\.masteram\.us|is','https://masteram.us',$text);

$text = preg_replace('|/away\?url=https:\/\/wwww\.masteram\.us|is','https://masteram.us"',$text);

return($text);

}

/*
-----------------------------------------------------------------
Вывод ника через бб-код
-----------------------------------------------------------------
*/
public static function us_bb($msg) {
preg_match_all('#user{(\d+)}#', $msg, $matches);
foreach($matches[1] as $number){
$nick = core::$dbs->queryFetch("SELECT user,icon,color,nick_eff FROM `users` WHERE `id` = ? LIMIT 1", [$number]);
$out = $nick['user'];
// градиент
$color = explode('-', base64_decode($nick['color']));
$out = (!empty($nick['color']) ? fnc::gradient($out,''.$color['0'],''.$color['1']) : '<b>'.$out.'</b>');
// эфект
$out = (($nick['nick_eff']) ? '<span class="ef'.(int)$nick['nick_eff'].'">'.$out.'</span>': $out);
$icon = (empty($nick['icon']) ? NULL : '<img src="/upload/icon/'.$nick['icon'].'" alt="*" align="middle"/>');
$msg = preg_replace("#user{\d+}#",(empty($nick['user'])?'<b>Удалён</b>': $icon.' <a href="/id'.$number.'">'.$out.'</a>'), $msg, 1);
unset($nick, $matches, $number);
}
return $msg;
}





/*
-----------------------------------------------------------------
Обработка времени
-----------------------------------------------------------------
*/

/*
-----------------------------------------------------------------
Парсинг ссылок
-----------------------------------------------------------------
За основу взята доработанная функция от форума phpBB 3.x.x
-----------------------------------------------------------------
*/
public static function highlight_url($text)
{
if (!function_exists('url_callback')) {
function url_callback($type, $whitespace, $url, $relative_url)
{
$orig_url = $url;
$orig_relative = $relative_url;
$url = htmlspecialchars_decode($url);

$relative_url = htmlspecialchars_decode($relative_url);
$text = '';
$chars = array('<', '>', '"');
$split = false;
foreach ($chars as $char) {
$next_split = strpos($url, $char);
if ($next_split !== false) {
$split = ($split !== false) ? min($split, $next_split) : $next_split;
}
}
if ($split !== false) {
$url = substr($url, 0, $split);
$relative_url = '';
} else if ($relative_url) {
$split = false;
foreach ($chars as $char) {
$next_split = strpos($relative_url, $char);
if ($next_split !== false) {
$split = ($split !== false) ? min($split, $next_split) : $next_split;
}
}
if ($split !== false) {
$relative_url = substr($relative_url, 0, $split);
}
}
$last_char = ($relative_url) ? $relative_url[strlen($relative_url) - 1] : $url[strlen($url) - 1];
switch ($last_char)
{
case '.':
case '?':
case '!':
case ':':
case ',':
$append = $last_char;
if ($relative_url) $relative_url = substr($relative_url, 0, -1);
else $url = substr($url, 0, -1);
break;

default:
$append = '';
break;
}
$short_url = $url;
switch ($type)
{
case 1:

$relative_url = preg_replace('/[&?]sid=[0-9a-f]{32}$/', '', preg_replace('/([&?])sid=[0-9a-f]{32}&/', '$1', $relative_url));
$url = $url . '/' . $relative_url;
$text = $relative_url;
if (!$relative_url) {
return $whitespace . $orig_url . '/' . $orig_relative;
}
break;
case 2:

$text = $short_url;
if (!isset($setting['direct_url']) || $setting['direct_url'])
if (!isset($setting['direct_url']) || $setting['direct_url'])
$url = '/away?url=' . rawurlencode($url);
//$url = '/away?url=' . htmlspecialchars($url);
break;
case 3:
$url = 'http://' . $url;
$text = $short_url;
if (!isset($setting['direct_url']) || $setting['direct_url'])
$url = '/away?url=' . rawurlencode($url);
//$url = '/away?url=' . htmlspecialchars($url);
break;

case 4:
$text = $short_url;
$url = 'mailto:' . $url;
break;
}
$url = htmlspecialchars($url);
$text = htmlspecialchars($text);
$append = htmlspecialchars($append);
return $whitespace . '<a class="link" href="' . $url . '">' . $text . '</a>' . $append;
}
}
$diurl = ''.homeurl;
// Обработка внутренние ссылки
$text = preg_replace_callback('#(^|[\n\t (>.])(' . preg_quote($diurl, '#') . ')/((?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@|]+|%[\dA-F]{2})*(?:/(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@|]+|%[\dA-F]{2})*)*(?:\?(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@/?|]+|%[\dA-F]{2})*)?(?:\#(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@/?|]+|%[\dA-F]{2})*)?)#iu', function ($m) {
return url_callback(1, $m[1], $m[2], $m[3]);
}, $text);

$text = preg_replace_callback('#(^|[\n\t (>.])([a-z][a-z\d+]*:/{2}(?:(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@|]+|%[\dA-F]{2})+|[0-9.]+|\[[a-zа-яё0-9.]+:[a-zа-яё0-9.]+:[a-zа-яё0-9.:]+\])(?::\d*)?(?:/(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@|]+|%[\dA-F]{2})*)*(?:\?(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@/?|]+|%[\dA-F]{2})*)?(?:\#(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@/?|]+|%[\dA-F]{2})*)?)#iu', function ($m) {
return url_callback(2, $m[1], $m[2], '');
}, $text);

$text = preg_replace_callback('#(^|[\n\t (>])(www\.(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@|]+|%[\dA-F]{2})+(?::\d*)?(?:/(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@|]+|%[\dA-F]{2})*)*(?:\?(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@/?|]+|%[\dA-F]{2})*)?(?:\#(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@/?|]+|%[\dA-F]{2})*)?)#iu', function ($m) {
return url_callback(3, $m[1], $m[2], '');
}, $text);
return $text;
}
/*
*/
static function notags($var = '') {

$var = preg_replace('#\[color=(.+?)\](.+?)\[/color]#si', '$2', $var);
$var = preg_replace('!\[bg=(#[0-9a-f]{3}|#[0-9a-f]{6}|[a-z\-]+)](.+?)\[/bg]!is', '$2', $var);
$var = preg_replace('#\[spoiler=(.+?)\](.+?)\[/spoiler]#si', '$2', $var);
$replace = array(
'[center]' => '',
'[/center]' => '',
'[small]' => '',
'[/small]' => '',
'[big]' => '',
'[/big]' => '',
'[green]' => '',
'[/green]' => '',
'[red]' => '',
'[/red]' => '',
'[blue]' => '',
'[/blue]' => '',
'[b]' => '',
'[/b]' => '',
'[i]' => '',
'[/i]' => '',
'[u]' => '',
'[/u]' => '',
'[s]' => '',
'[/s]' => '',
'[quote]' => '',
'[/quote]' => '',
'[c]' => '',
'[/c]' => '',
'[*]' => '',
'[/*]' => ''
);
return strtr($var, $replace);
}

public static function highlight_code($var)
    {
        $var = preg_replace_callback('#\[php\](.+?)\[\/php\]#s', 'self::phpCodeCallback', $var);
        $var = preg_replace_callback('#\[code=(.+?)\](.+?)\[\/code]#is', 'self::codeCallback', $var);

        return $var;
    }

    private static $geshi;

    private static function phpCodeCallback($code)
    {
        return self::codeCallback(array(1 => 'php', 2 => $code[1]));
    }

    private static function codeCallback($code)
    {
        $parsers = array(
            'php'  => 'php',
            'css'  => 'css',
            'html' => 'html5',
            'js'   => 'javascript',
            'sql'  => 'sql',
            'xml'  => 'xml',
        );

        $parser = isset($code[1]) && isset($parsers[$code[1]]) ? $parsers[$code[1]] : 'php';

        if (null === self::$geshi) {
            require_once 'geshi.php';
            self::$geshi = new \GeSHi;
            self::$geshi->set_link_styles(GESHI_LINK, 'text-decoration: none');
            self::$geshi->set_link_target('_blank');
            self::$geshi->enable_line_numbers(GESHI_FANCY_LINE_NUMBERS, 2);
            self::$geshi->set_line_style('background: rgba(255, 255, 255, 0.5)', 'background: rgba(255, 255, 255, 0.35)', false);
            self::$geshi->set_code_style('padding-left: 6px; white-space: pre-wrap');
        }

        self::$geshi->set_language($parser);
        $php = strtr($code[2], array('<br />' => ''));
        $php = html_entity_decode(trim($php), ENT_QUOTES, 'UTF-8');
        self::$geshi->set_source($php);

        return '<div style="background-color: #e0e6e9; border: 1px dotted #9faebb; margin-top: 4px; padding: 0 2px 0 2px; overflow-x: auto">' . self::$geshi->parse_code() . '</div>';
    }

/*
-----------------------------------------------------------------
Обработка URL в тэгах BBcode
-----------------------------------------------------------------
*/
public static function OLD_highlight_url($var)
{
if (!function_exists('process_url')) {
function process_url($url)
{
$diurl = ''.homeurl;
$tmp = parse_url($url[1]);
$tmp_url = 'http://'.$tmp['host'];
if ('https://' . $tmp['host'] == $diurl OR $tmp_url == $diurl) {
return '<a class="link" href="' . $url[1] . '">' . $url[2] . '</a>';
} else {
return '<a class="link" href="/away?url=' . rawurlencode($url[1]) . '">' . $url[2] . '</a>';
}
}
}
return preg_replace_callback('~\\[url=(https?://.+?)\\](.+?)\\[/url\\]~', 'process_url', $var);
}

/*
-----------------------------------------------------------------
Обработка
-----------------------------------------------------------------
*/
private static function highlight_bb($var)
{
// Список поиска '#\[img](.+?)\[/img]#is', // картинка

$search = array(
'#\[img](.+?)\[/img]#is', // картинка
'#\[center](.+?)\[/center]#is', // центр
'#\[b](.+?)\[/b]#is', // Жирный
'#\[i](.+?)\[/i]#is', // Курсив
'#\[u](.+?)\[/u]#is', // Подчеркнутый
'#\[s](.+?)\[/s]#is', // Зачеркнутый
'#\[small](.+?)\[/small]#is', // Маленький шрифт
'#\[big](.+?)\[/big]#is', // Большой шрифт
'#\[red](.+?)\[/red]#is', // Красный
'#\[green](.+?)\[/green]#is', // Зеленый
'#\[blue](.+?)\[/blue]#is', // Синий
'!\[color=(#[0-9a-f]{3}|#[0-9a-f]{6}|[a-z\-]+)](.+?)\[/color]!is', // Цвет шрифта
'!\[bg=(#[0-9a-f]{3}|#[0-9a-f]{6}|[a-z\-]+)](.+?)\[/bg]!is', // Цвет фона
'#\[(quote|c)](.+?)\[/(quote|c)]#is', // Цитата
'#\[\*](.+?)\[/\*]#is', // Список
'#\[spoiler=(.+?)](.+?)\[/spoiler]#is' // Спойлер
);



// Список замены
$replace = array(
'<a class="link" href="$1"><img src="$1" width="90" height="90" alt="*"></a>', // картинка
//'<div align="center">$1</div>', // центр
'<center>$1</center>', // центер
'<span style="font-weight: bold">$1</span>', // Жирный
'<span style="font-style:italic">$1</span>', // Курсив
'<span style="text-decoration:underline">$1</span>', // Подчеркнутый
'<span style="text-decoration:line-through">$1</span>', // Зачеркнутый
'<span style="font-size:x-small">$1</span>', // Маленький шрифт
'<span style="font-size:large">$1</span>', // Большой шрифт
'<span style="color:red">$1</span>', // Красный
'<span style="color:green">$1</span>', // Зеленый
'<span style="color:blue">$1</span>', // Синий
'<span style="color:$1">$2</span>', // Цвет шрифта
'<span style="background-color:$1">$2</span>', // Цвет фона
'<span class="quote" style="display:block">$2</span>', // Цитата
'<span class="bblist">$1</span>', // Список
'<div><div class="spoilerhead" style="cursor:pointer;" onclick="var _n=this.parentNode.getElementsByTagName(\'div\')[1];if(_n.style.display==\'none\'){_n.style.display=\'\';}else{_n.style.display=\'none\';}">$1 (+/-)</div><div class="spoilerbody" style="display:none">$2</div></div>' // Спойлер
);

return preg_replace($search, $replace, $var);
}
private static function highlight_bb_img($var)
{

$search1 = array(
//'#\[img](.+?)\[/img]#is', // картинка
'/\[img\]((http|https):\/\/[a-zA-Z_0-9\-\.\/]*\.(jpg|gif|png))\[\/img\]/is',
);

// Список замены

$replace1 = array(
'<a href="$1" target="_blank"><img src="$1" width="90" height="90" alt="*"></a>'); // картинка

return preg_replace($search1, $replace1, $var);
}

/*
-----------------------------------------------------------------
Панель кнопок bbCode (для компьютеров)
-----------------------------------------------------------------
*/
public static function auto_bb($form, $field = "content")
{
	$_SESSION['form_name'] = $form;
	$_SESSION['textarea_name'] = $field;
		
	$setting = array();
	$setting = unserialize(core::$user['setting']);
	
	if(empty($setting['new_form']))
	{	
		$colors = array(
		'ffffff', 'bcbcbc', '708090', '6c6c6c', '454545',
		'fcc9c9', 'fe8c8c', 'fe5e5e', 'fd5b36', 'f82e00',
		'ffe1c6', 'ffc998', 'fcad66', 'ff9331', 'ff810f',
		'd8ffe0', '92f9a7', '34ff5d', 'b2fb82', '89f641',
		'b7e9ec', '56e5ed', '21cad3', '03939b', '039b80',
		'cac8e9', '9690ea', '6a60ec', '4866e7', '173bd3',
		'f3cafb', 'e287f4', 'c238dd', 'a476af', 'b53dd2'
		);
		$i = 1;
		$font_color = '';
		$bg_color = '';
		foreach ($colors as $value) {
		$font_color .= '<a href="javascript:tag(\'[color=#' . $value . ']\', \'[/color]\'); show_hide(\'color\');" style="background-color:#' . $value . ';"></a>';
		$bg_color .= '<a href="javascript:tag(\'[bg=#' . $value . ']\', \'[/bg]\'); show_hide(\'bg\');" style="background-color:#' . $value . ';"></a>';
		}
		$smile = unserialize(file_get_contents(inc.'cache/smile.dat'));
		$res_sm = '';
		foreach ($smile as $value)
		$res_sm .= '<a href="javascript:tag(\':' . $value . '\', \':\'); show_hide(\'sm\');">:' . $value . ':</a> ';
		$bb_smileys .= fnc::smile($res_sm);

		$out = '<style>.color a {float:left; display: block; width: 10px; height: 10px; margin: 1px; border: 1px solid black;}</style>
		<script language="JavaScript" type="text/javascript">
		function tag(text1, text2) {
		if ((document.selection)) {
		document.' . $form . '.' . $field . '.focus();
		document.' . $form . '.document.selection.createRange().text = text1+document.' . $form . '.document.selection.createRange().text+text2;
		} else if(document.forms[\'' . $form . '\'].elements[\'' . $field . '\'].selectionStart!=undefined) {
		var element = document.forms[\'' . $form . '\'].elements[\'' . $field . '\'];
		var str = element.value;
		var start = element.selectionStart;
		var length = element.selectionEnd - element.selectionStart;
		element.value = str.substr(0, start) + text1 + str.substr(start, length) + text2 + str.substr(start + length);
		} else {
		document.' . $form . '.' . $field . '.value += text1+text2;
		}
		}
		function show_hide(elem) {
		obj = document.getElementById(elem);
		if( obj.style.display == "none" ) {
		obj.style.display = "block";
		} else {
		obj.style.display = "none";
		}
		}
		</script>
		<a href="javascript:tag(\'[b]\', \'[/b]\')"><img src="/icon/bb/bold.gif" alt="b" title="Жирный" border="0"/></a>
		<a href="javascript:tag(\'[i]\', \'[/i]\')"><img src="/icon/bb/italics.gif" alt="i" title="Курсив" border="0"/></a>
		<a href="javascript:tag(\'[u]\', \'[/u]\')"><img src="/icon/bb/underline.gif" alt="u" title="Подчеркнутый" border="0"/></a>
		<a href="javascript:tag(\'[s]\', \'[/s]\')"><img src="/icon/bb/strike.gif" alt="s" title="" border="0"/></a>
		<a href="javascript:tag(\'[*]\', \'[/*]\')"><img src="/icon/bb/list.gif" alt="s" title="" border="0"/></a>
		<a href="javascript:tag(\'[spoiler=Осторожно, спойлер]\', \'[/spoiler]\');"><img src="/icon/bb/sp.gif" alt="spoiler" title="Спойлер" border="0"/></a>
		<a href="javascript:tag(\'[c]\', \'[/c]\')"><img src="/icon/bb/quote.gif" alt="quote" title="Цитата" border="0"/></a>
		<a href="javascript:tag(\'[php]\', \'[/php]\')"><img src="/icon/bb/php.gif" alt="cod" title="Код" border="0"/></a>
		<a href="javascript:tag(\'[url=]\', \'[/url]\')"><img src="/icon/bb/link.gif" alt="url" title="Ссылка" border="0"/></a>
		<a href="http://masteram.us/plugin/smile/index" title="*"border="0"> <img src="/icon/bb/smileys.gif" alt="smile" title="smile" border="0"/></a>
		<a href="/faq/bb" title="*"border="0"> <img src="/icon/bb/code.png" alt="bb" title="bb" border="0"/></a>
		<a href="javascript:tag(\'[center]\', \'[/center]\')"><img src="/icon/bb/center.gif" alt="cod" title="Центрация" border="0"/></a>
		<a href="javascript:tag(\'[img]\', \'[/img]\')"><img src="/icon/bb/img.gif" alt="image" title="Вставка изображения" border="0"/></a><br />';
		/*if (self::$user_id) {
		$out .= ' <a href="javascript:show_hide(\'sm\');"><img src="" alt="sm" title="" border="0"/></a><br />
		<table id="sm" style="display:none"><tr><td>' . $bb_smileys . '</td></tr></table>
		<div id="sm" style="display:none">'.$bb_smileys.'</div>';
		}else $out .= '<br />';*/
		$out .= '<div id="color" class="bbpopup" style="display:none;">Шрифт: '.$font_color.'</div>'.
		'<div id="bg" class="bbpopup" style="display:none">Фон: '.$bg_color.'</div>';
		return $out;
	}
	else
	{
		?>
	
		<script type="text/javascript" src="/private/block_smiles.js"></script>
		<link href="/private/block_smiles.css" rel="stylesheet" type="text/css"/>
	
		<style>
			.last_smiles
			{
				display: block;
				text-align: center;
			}

			.smile img
			{
				max-width: 30px;
				max-height: 30px;
			}
		</style>
		<div class="ank">
			<div id="last_smiles"></div>
				
			<div class="block_smiles">
				<div class="block_smiles_title">
					<span onclick="togle_smile_block();">смайлы для вставки </span>
					<span OnClick="show_smile_block(0)" class="block_smiles_close">X</span>
					<span OnClick="show_smile_block(1)" class="block_smiles_win"><img src="/private/img/ico_win.png"></span>
				</div>
				<div id="block_smiles_cont">
					<div class="block_smiles_menu">
						
						<img OnClick="show_smile_block(1)" src="/private/img/smile.png" alt="*">
						<img OnClick="show_smile_block('bb_code')" src="/private/img/bb.png" alt="*">
					</div>
					
					<div id="block_smiles_content"></div>
				</div>
			</div>
		</div>
		<?PHP
	}
}
		
} // End  class bbcode