<?
class core {
public static $ip;			            // IP Адрес
public static $ipp;
public static $proxy = 0; 				// IP адрес за прокси-сервером
public static $user_agent;              // User Agent
public static $conf;          // Конфигурация системы
public static $browser = false;         // Мобильный браузер
public static $dbs = false;             // Инициируем $dbs для подключения к БД через класс PDO
public static $core_error = array();  	// Ошибки ядра

public static $user_id = false;         // Идентификатор пользователя
public static $level = 0;               // Права доступа
public static $user = array();          // Все данные пользователя
public static $setting = array();		// Все настройки пользователя

function __construct(){
$ipp = ip2long($_SERVER['REMOTE_ADDR']) or die('Invalid IP');
self::$ipp = sprintf("%u", $ipp);
self::$ip = long2ip($ipp);
if (isset($_SERVER['HTTP_X_FORWARDED_FOR']) && preg_match_all('#\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}#s', $_SERVER['HTTP_X_FORWARDED_FOR'], $vars)) {
foreach ($vars[0] AS $var) {
$proxy = ip2long($var);
if ($proxy && $proxy != $ipp && !preg_match('#^(10|172\.16|192\.168)\.#', $var)) {
self::$proxy = sprintf("%u", $proxy);
break;
}
}
}

// Получаем UserAgent
self::$user_agent = htmlspecialchars(trim($_SERVER['HTTP_USER_AGENT']));
/*if (isset($_SERVER["HTTP_X_OPERAMINI_PHONE_UA"]) && strlen(trim($_SERVER['HTTP_X_OPERAMINI_PHONE_UA'])) > 5)
self::$user_agent = 'Opera Mini: ' . htmlspecialchars(mb_substr(trim($_SERVER['HTTP_X_OPERAMINI_PHONE_UA']), 0, 150));
elseif(isset($_SERVER['HTTP_USER_AGENT']))
self::$user_agent = htmlspecialchars(mb_substr(trim($_SERVER['HTTP_USER_AGENT']), 0, 150));
else self::$user_agent = 'Not Recognised';*/
if (get_magic_quotes_gpc()) $this->del_slashes();
$this->connect();
$this->sid();
$this->autorize();
self::$browser = $this->browser();
$this->conf();
self::$conf = $this->conf_site();
}
function __destruct(){
self::$dbs = Null;
}

private function del_slashes(){
$in = array(
&$_GET,
&$_POST,
&$_COOKIE
);
while ((list($k, $v) = each($in)) !== FALSE) {
foreach ($v as $key => $val) {
if (!is_array($val)) {
$in[$k][$key] = stripslashes($val);
continue;
}
$in[] = & $in[$k][$key];
}
}
unset($in);
if (!empty($_FILES)) foreach ($_FILES as $k => $v) $_FILES[$k]['name'] = stripslashes((string)$v['name']);
}

public static function connect() {
require_once inc.'core/connect.php';
require_once inc.'core/class/pdo.php';
if (!isset($dbs)) {
self :: $dbs = new PDO_('mysql:host=' . DBHOST . ';port=' . DBPORT . ';dbname=' . DBNAME, DBUSER, DBPASS);
self :: $dbs -> exec('SET CHARACTER SET utf8');
self :: $dbs -> exec('SET NAMES utf8');
} else self::$dbs;
}
private function autorize(){
$user_id = False;
$user_ps = False;
if (isset($_COOKIE['cookie_id']) && isset($_COOKIE['cookie_ps'])) {
$user_id  = abs((int)base64_decode($_COOKIE['cookie_id']));
$user_ps  = fnc::check(base64_decode($_COOKIE['cookie_ps']));
}
if ($user_id && $user_ps) {
$user = self :: $dbs->query("SELECT * FROM `users` WHERE `id`=? LIMIT 1;", array($user_id));
if($user->rowCount() == 1){
$user = $user -> fetch(PDO::FETCH_ASSOC);
if($user_ps === $user['pass']){
self::$user = $user;
self::$user_id = $user['id'];
self::$user['level'] = $user['level'];
self::$setting = $this->user_set();
}else $this->user_unset();
}else $this->user_unset();
} else $this->user_unset();
}

private function default_user_set(){
return array(
'translit' 			=> 0,
'smile' 			=> 1,
'safe' 				=> 0,
'style' 			=> 'blue2',
'picture' 			=> 1,
'ghost' 			=> 0,
'page_size'			=> 1,
'time' 				=> 1,
'avatar'			=> 1,
'gradient'			=> 1,
'limit' 			=> 10,
'direct_url'		=> 0,
'act_forum' 			=> 1);
}
private function user_set(){
return unserialize(self::$user['setting']);
}

private function conf_site(){
if(!file_exists(inc.'cache/set_core.dat')){
$create_core_set = fopen(inc.'cache/set_core.dat', "w+");
fputs($create_core_set, '');
fclose($create_core_set);
chmod(inc.'cache/set_core.dat', 0666);
$core_set = serialize(array(
'open_site' 		=> 1, 			// статус сайта вкл - выкл
'homeurl'			=> 'https://masteram.us',
'open_reg'			=> 1,
'open_clon_reg'		=> 1,
'guests' 			=> 1,			// гостевой доступ
'guest_name'		=> 'Гость',		// никнейм для гостя
'mod_forum' 		=> 1,			// статус форума вкл - выкл
'max_size_forum'	=> 1024,
'style' 			=> 'blue2',		// тема по умолчанию
'photo_kb'			=> 2,
'photo_w'			=> 1800,
'photo_h'			=> 980));
file_put_contents(inc.'cache/set_core.dat', $core_set);
}
return unserialize(file_get_contents(inc.'cache/set_core.dat'));
}
private function user_unset(){
self::$setting = $this->default_user_set(); // задаем стандартные настройки
unset($_SESSION['session_id']);				// уничтожаем сессию ID
unset($_SESSION['session_ps']);				// уничтожаем сессию пароля
SetCookie('cookie_id','');					// уничтожаем куку ID
SetCookie('cookie_ps','');					// уничтожаем куку пароля
self::$user_id = False;						// уничтожаем ID
self::$level   = 0;							// уровень доступа выставляем на 0
}

private function sid(){
session_name('sessionid');
session_start();
}
private function browser(){
if (isset($_SESSION['browser'])) {
return $_SESSION['browser'] == 1 ? true : false;
}
$user_agent = strtolower($_SERVER['HTTP_USER_AGENT']);
$accept = strtolower($_SERVER['HTTP_ACCEPT']);
if ((strpos($accept, 'text/vnd.wap.wml') !== false) || (strpos($accept, 'application/vnd.wap.xhtml+xml') !== false)) {
$_SESSION['browser'] = 1;
return true;
}
if (isset($_SERVER['HTTP_X_WAP_PROFILE']) || isset($_SERVER['HTTP_PROFILE'])) {
$_SESSION['browser'] = 1;
return true;
}
if (preg_match('/android|avantgo|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i', $user_agent) || preg_match('/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|e\-|e\/|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(di|rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|xda(\-|2|g)|yas\-|your|zeto|zte\-/i', substr($user_agent, 0, 4))) {
$_SESSION['browser'] = 1;
return true;
}
$_SESSION['browser'] = 2;
return false;
}
public static function conf(){
$conf = self::$dbs->queryFetch("SELECT * FROM setting WHERE klu4 = ?",array(1));
return $conf;
}
}
?>
