<?php
$conf['title'] = 'Добавить заявку';
require_once(inc . 'core/header.php');
fnc::head('Добавить заявку');
if (empty(core::$user['wmid'])) {
echo '<div class="raz">Заполните и подтвердите WMID!</div>';
echo '<div class="menu_j"><a href="/" class="top_menu_j"> Главная</a></div>';
require_once(inc . 'core/footer.php');
die();
}
if (core::$user['gar'] == 1) {
echo '<div class="raz">Вы уже подавали заявку!</div>';
echo '<div class="menu_j"><a href="/" class="top_menu_j"> Главная</a></div>';
require_once(inc . 'core/footer.php');
die();
}
if (isset($_POST['ok'])) {
$pravila = fnc::check($_POST['pravila']);
$dop = fnc::check($_POST['dop']);
$polo = fnc::check($_POST['polo']);
$email = fnc::check($_POST['mail']);
$icq = abs((int)$_POST['icq']);
$rules = abs((int)$_POST['rules']);
$price = fnc::check($_POST['price']);
if (empty($pravila) OR mb_strlen($pravila)<3) {
$err[] = 'Заполните поле Правила';
} elseif (empty($polo) OR mb_strlen($polo)<3) {
$err[] = 'Заполните поле Положения';
} elseif (empty($email) OR mb_strlen($email)<3) {
$err[] = 'Заполните поле E-mail';
} elseif (empty($icq) OR mb_strlen($icq)<3) {
$err[] = 'Заполните поле ICQ';
} elseif (empty($price) OR mb_strlen($price)<3) {
$err[] = 'Заполните поле Расценки';
}
elseif (empty($dop) OR mb_strlen($dop)<3) {
$err[] = 'Заполните поле Дополнения';
}
elseif (!is_numeric($icq)) {
$err[] = 'Номер ICQ должен состоять только из цифр!';
} elseif (empty($rules)) {
$err[] = 'Ошибочка...';
}
if (empty($err)) {
core::$dbs->query("INSERT INTO `garant` SET `pravila` = ?, `polo` = ?, `dop` = ?, `mail` = ?, `icq` = ?, `price` = ?, `user_id` = ?,
`time` = ?", array($pravila,$polo,$dop,$email,$icq,$price,$user_id,time()));
fnc::message('<b>Ваша заявка отправлена на рассмотрение Администрации!</b>');
echo '<div class="menu_j"><a href="/" class="top_menu_j"> Главная</a></div>';
require_once(inc . 'core/footer.php');
die();
} else {
echo '<div class="error">';
foreach($err as $error) {
echo '<b>'.$error.'</b><br/>';
}
echo '</div>';
}
}
echo '<div class="raz"><form action="/garant/add" method="POST">* Правила:<br/><textarea name="pravila"></textarea><br/>Дополнения:<br/><textarea name="dop"></textarea><br/> * Положения:<br/><textarea name="polo"></textarea><br/>* Рассценки:<br/><textarea name="price"></textarea><br/>* E-mail:<br/><input type="text" name="mail"/><br/>
* ICQ:<br/><input type="text" name="icq"/><br/><label><input type="checkbox" name="rules" value="1"/></label> Я ознакомлен(а) с <a href="/garant/rules">правилами приёма заявок</a> и согласен (согласна)<br/> <br/><input type="submit" name="ok" value="Добавить"/></form></div>';
echo '<div class="raz">* Поля обязательные для заполнения</div>';
?>
