<?PHP
function getExtension($str)
{
$i = strrpos($str,".");
if (!$i) { return ""; }
$l = strlen($str) - $i;
$ext = substr($str,$i+1,$l);
return $ext;
}

/*для генерации случайной строки*/
function generateCode($length=6) 
{

	$chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPRQSTUVWXYZ0123456789";

	$code = "";

	$clen = strlen($chars) - 1;  
	while (strlen($code) < $length) {

			$code .= $chars[mt_rand(0,$clen)];  
	}

	return $code;

}

/*Меню навигиции*/
function page_nav($page,$total,$cssClass,$dopLink)
{
	if ($page != 1) $pervpage = '<a href= ?'.$dopLink.'page=1><button class="button_navig"><<</button></a>  
								   <a href= ?'.$dopLink.'page='. ($page - 1) .'><button class="button_navig"><</button></a>';  
	// Проверяем нужны ли стрелки вперед  
	if ($page != $total) $nextpage = ' <a href= ?'.$dopLink.'page='. ($page + 1) .'><button class="button_navig">></button></a>  
									   <a href= ?'.$dopLink.'page=' .$total. '><button class="button_navig">>></button></a>';  

	// Находим две ближайшие станицы с обоих краев, если они есть  
	if($page - 2 > 0) $page2left = '<a href= ?'.$dopLink.'page='. ($page - 2) .'><button class="button_navig">'. ($page - 2) .'</button></a>';  
	if($page - 1 > 0) $page1left = '<a href= ?'.$dopLink.'page='. ($page - 1) .'><button class="button_navig">'. ($page - 1) .'</button></a>';  
	if($page + 2 <= $total) $page2right = '<a href= ?'.$dopLink.'page='. ($page + 2) .'><button class="button_navig">'. ($page + 2) .'</button></a>';  
	if($page + 1 <= $total) $page1right = '<a href= ?'.$dopLink.'page='. ($page + 1) .'><button class="button_navig">'. ($page + 1) .'</button></a>'; 

	// Вывод меню  
	if($total > $num-1)
	{
		echo '<div class="'.$cssClass.'">  
				<center>
					'.$pervpage.$page2left.$page1left.'<button class="button_navig">'.$page.'</button>'.$page1right.$page2right.$nextpage.'
				</center>
			</div>';  
	}
}

/*Меню навигиции для Ajax*/
function page_nav_Ajax($page,$total,$cssClass,$dopLink)
{
	if ($page != 1) $pervpage = '<button onClick="nav(1)" class="button_navig"><<</button>  
								   <button onClick="nav('.($page - 1).')" class="button_navig"><</button>';  
	// Проверяем нужны ли стрелки вперед  
	if ($page != $total) $nextpage = ' <button onClick="nav('.($page + 1).')" class="button_navig">></button>  
									   <button onClick="nav('.$total.')" class="button_navig">>></button>';  

	// Находим две ближайшие станицы с обоих краев, если они есть  
	if($page - 2 > 0) $page2left = '<button onClick="nav('.($page - 2).')" class="button_navig">'. ($page - 2) .'</button>';  
	if($page - 1 > 0) $page1left = '<button onClick="nav('.($page - 1).')" class="button_navig">'. ($page - 1) .'</button>';  
	if($page + 2 <= $total) $page2right = '<button onClick="nav('.($page + 2).')" class="button_navig">'. ($page + 2) .'</button>';  
	if($page + 1 <= $total) $page1right = '<button onClick="nav('.($page + 1).')" class="button_navig">'. ($page + 1) .'</button>'; 

	// Вывод меню  
	if($total > $num-1)
	{
		echo '<div class="'.$cssClass.'">  
				<center>
					'.$pervpage.$page2left.$page1left.'<button class="button_navig">'.$page.'</button>'.$page1right.$page2right.$nextpage.'
				</center>
			</div>';  
	}
}
?>